import 'package:test_helper/src/list_expecter.dart';

/*
class Params {}

class InlineData<TData, TResult> {
  TData data;
  TResult expectedResult;

  InlineData(this.data, this.expectedResult);
}

void theoryResultAsync<TData, TResult>(
    List<InlineData<TData, TResult>> inlineData,
    Future<TResult> Function(TData data) theory) async {
  for (var dataItem in inlineData) {
    final res = await theory(dataItem);
    expect(res, dataItem.expectedResult);
  }
}
*/

void theory<TData>(List<TData> inlineData, void Function(TData data) theory) {
  inlineData.forEach(theory);
}

void theoryResult<TData, TResult>(List<TData> inlineData,
    List<TResult> expected, TResult Function(TData data) act) {
  final results = inlineData.map(act).toList();
  expectList(results, expected);
}
